unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  ShellAPI;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function ProgAssocie(NomFichier: string): string;
// cette fonction renvoie l'xcutable associ  "NomFichier"
// NomFichier doit tre un fichier existant.
var
  Executable: array [0..255] of Char;
begin
  FindExecutable(PChar(ExtractFileName(NomFichier)),
                 PChar(ExtractFilePath(NomFichier)),
                 Executable);
  result:= string(Executable);
end;

function LanceEtAttendFin(NomFichier: string): boolean;
{permet de lancer un excutable. NomFichier est le nom avec chemin     }
{de cet excutable ou d'un raccourci qui pointe vers cet excutable.   }
{ notre programme est arrt tant que l'excutable n'est pas fini      }
{tout est arrt on ne peut donc mme plus dplacer sa fentre.        }
{ il est donc prfrable de la rendre invisible avant le lancement     }
{de cette fonction.                                                    }
{ LanceAppliAttenteFin renvoie true si le lancement s'est bien pass   }
var
  Executable, Fichier: string;
  StartInfo: TStartupInfo;
  ProcessInformation: TProcessInformation;
  PCharFichier: PChar;
begin
  result:= true;
  // pour si on a choisi un fichier et non directement un executable,
  // ProgAssocie va nous renvoyer l'excutable associ.
  Executable:= ProgAssocie(NomFichier);
  // pour pas que Fichier soit considr comme paramtre de Executable
  // si fichier est dja l'excutable:
  // concrtement, si on choisi comme fichier NotePad.exe, pour pas
  // qu'il ne lance Wordpad.exe avec comme paramtre WordPad.exe :
  if Uppercase(ExtractFileName( Executable))
      <>Uppercase(ExtractFileName(NomFichier)) 
  then   PCharFichier:=PChar( ' "' + NomFichier + '"')
  else PCharFichier:=nil;
  ZeroMemory(@StartInfo,
             sizeof(StartInfo)); // remplie de 0 StartInfo
  StartInfo.cb:= sizeof(StartInfo);
  if CreateProcess(PChar(Executable),
                   PCharFichier,
                   nil,
                   nil,
                   true,
                   0,
                   nil,
                   nil,
                   StartInfo,
                   ProcessInformation)
    // attend que l'application dsigne par le handle
    //ProcessInformation.hProcess soit termine :
    then WaitForSingleObject(ProcessInformation.hProcess, INFINITE)
    else result:= false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenDialog1.Execute;
  //facultatif : permet de rendre invisible notre application
  Visible:= false;
  if not (LanceEtAttendFin(OpenDialog1.FileName))
    then ShowMessage('erreur au lancement de l''application'
                     + Opendialog1.FileName);
  // remet visible notre application
  visible:= true;
  ShowMessage ('fini');
end;

end.



